
-- Telelader
-- Specialization class for Telelader functionality

-- @author  Kyosho
-- @date  29/11/2010



MoveTelearm = {};

function MoveTelearm.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function MoveTelearm:load(xmlFile)

	self.moveableTelearm = {};
	self.moveableTelearm.index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.moveableTelearm#index"));
	self.moveableTelearm.max = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.moveableTelearm#maxY"), 0); 
	self.moveableTelearm.min = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.moveableTelearm#minY"), 0); 
	
end;

function MoveTelearm:delete()
end;

function MoveTelearm:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MoveTelearm:keyEvent(unicode, sym, modifier, isDown)

end;

function MoveTelearm:update(dt)

	if self.moveableTelearm ~= nil then
		local xAttacher, yAttacher, zAttacher = getTranslation(self.moveableTelearm.index);
		local maxY = self.moveableTelearm.max;
		local minY = self.moveableTelearm.min;
		local moveSpeed = 0.008;
			if InputBinding.isPressed(InputBinding.Telearm_UP) then
				if zAttacher < maxY then
					zAttacher = zAttacher + moveSpeed;
				else
					zAttacher = maxY;
				end;
			elseif InputBinding.isPressed(InputBinding.Telearm_DOWN) then
				if zAttacher > minY then
					zAttacher = zAttacher - moveSpeed;
				else
					zAttacher = minY;
				end;
			end;
		setTranslation(self.moveableTelearm.index, xAttacher, yAttacher, zAttacher);
	end;
				
end;

function MoveTelearm:onLeave()

end;

function MoveTelearm:draw()

end;

function MoveTelearm:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

